function Cmp05000Controller(ScreenService, General, localStorageEngine, MessageService) {

    var todasUnidades = [];

    this.setInitialValues = function (widget) {
        
        var widgetCurrentRow;
        var reportField         = widget.getField('REPORT_NAME');
        var tipoCustoField      = widget.getField('NMTIPOCUSTO');

        if (!widget.currentRow.NRORG) {
            widget.newRow();
        }

        widgetCurrentRow = widget.currentRow;

        tipoCustoField.reload().then(function(){
            widgetCurrentRow.CDTIPOCUSTO    = tipoCustoField.dataSource.getFirstRow().CDTIPOCUSTO;
            widgetCurrentRow.NMTIPOCUSTO    = tipoCustoField.dataSource.getFirstRow().NMTIPOCUSTO;
        });

        widgetCurrentRow.CD_REPORT_NAME = reportField.dataSource.getFirstRow().value;
        widgetCurrentRow.REPORT_NAME    = reportField.dataSource.getFirstRow().name;

        this.montaListaTodasUnidades();
    };

    this.defineSelectWidget = function(field){
        if(field.selectWidget){
            field.selectWidget.dataSourceFilter = field.dataSourceFilter;
        }
    };
    this.montaListaTodasUnidades = function(){
        localStorageEngine.getDataSource('/unidades').then(function(unidades){
            unidades.forEach(function(unidade){
                todasUnidades.push(unidade.CDFILIAL);
            });
        });
    };
    this.filtraUnidadeSolicitante = function(fieldUnidades, stringUnidades, cdRegiao){
        
        var unidades = '';
        
        if(stringUnidades && cdRegiao.length) {
            unidades = stringUnidades.split('_');
            fieldUnidades.dataSourceFilter = [
                {"name": "CDFILIAL", "value": "", "operator": "IN"},
                {"name": "CDREGIAO", "value": "", "operator": "IN"}
            ];

            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades, 'CDREGIAO': cdRegiao});
        
        } else {
            if(stringUnidades){
                unidades = stringUnidades.split('_');
                
                fieldUnidades.dataSourceFilter = [{"name": "CDFILIAL","value": "","operator": "IN"}];
                this.defineSelectWidget(fieldUnidades);
                General.onClickDependentField(fieldUnidades, {'CDFILIAL': unidades});
            
            } else{
                if(cdRegiao.length){
                    fieldUnidades.dataSourceFilter = [{"name": "CDREGIAO","value": "","operator": "IN"}];
                    this.defineSelectWidget(fieldUnidades);
                    General.onClickDependentField(fieldUnidades, {'CDREGIAO': cdRegiao});
                } else{
                    fieldUnidades.dataSourceFilter = [{"name": "NRORG","value": "","operator": "="}];
                    this.defineSelectWidget(fieldUnidades);
                    General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
                }
            }
        }
    };

    this.filtraUnidadeLancamento = function(fieldUnidades, cdRegiao){
        
        if(cdRegiao.length) {
            fieldUnidades.dataSourceFilter = [{"name": "CDREGIAO","value": "","operator": "IN"}];
            this.defineSelectWidget(fieldUnidades);
            General.onClickDependentField(fieldUnidades, {'CDREGIAO': cdRegiao});
        } else {
            fieldUnidades.dataSourceFilter = [{"name": "NRORG", "value": "", "operator": "="}];
            General.onClickDependentField(fieldUnidades, {'NRORG': getLocalVar('NRORG')});
        }
    };

    this.filtraSolicita = function (widget) {
        
        var solicitaDataSourceFilter    = [];
        var cdFilialSoliField           = widget.getField('CDFILSOLI').value();
        var todasFiliaisSoli            = widget.getField('CDFILSOLI_checkbox').checked;
        var cdFilialLanField            = widget.getField('CDFILLAN').value();
        var todasFiliaisLanc            = widget.getField('CDFILLAN_checkbox').checked;
        var nrSoliField                 = widget.getField('NRSOLI');
        var cdfillanca                  = '';
        var cdfilsoli                   = '';

        if(cdFilialSoliField) {
            cdfilsoli = cdFilialSoliField;
        }
        else {
            if(todasFiliaisSoli){
                cdfilsoli = todasUnidades;
            }
        }

        solicitaDataSourceFilter.push({"name": "CDFILSOLI", "operator": "IN", "value": ""});

        if(cdFilialLanField) {
            cdfillanca = cdFilialLanField;
        }
        else {
            if(todasFiliaisLanc) {
                cdfillanca = todasUnidades;
            }
        }

        solicitaDataSourceFilter.push({"name": "CDFILLANCA", "operator": "IN", "value": ""});

        nrSoliField.dataSourceFilter = solicitaDataSourceFilter;
        this.defineSelectWidget(nrSoliField);
        General.onClickDependentField(nrSoliField, {'CDFILSOLI': cdfilsoli, 'CDFILLANCA': cdfillanca});
    };

    this.criaRelatorio = function (widget, currentRow) {
        var reportName = widget.currentRow.CD_REPORT_NAME;

        if (widget.isValid() && this.validaData(currentRow) && this.validaProduto(currentRow.CDPRODINI, currentRow.CDPRODFIN)) {

            General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, reportName]);    
        }
    };
            
    this.abreRelatorio = function(widget, currentRow, reportName) {

        if (widget.getField('CDREGIAO_checkbox').checked) {
            currentRow.CDREGIAO = "T";
        } else {
            currentRow.CDREGIAO = currentRow.CDREGIAO.join("_");
        }
        if (widget.getField('CDFILSOLI_checkbox').checked) {
            currentRow.CDFILSOLI = todasUnidades.join('_');
        } else {
            currentRow.CDFILSOLI = currentRow.CDFILSOLI.join("_");
        }
        if (widget.getField('CDFILLAN_checkbox').checked) {
            currentRow.CDFILLAN = todasUnidades.join('_');
        } else {
            currentRow.CDFILLAN = currentRow.CDFILLAN.join("_");
        }
        if (widget.getField('NRSOLI_checkbox').checked) {
            currentRow.NRSOLI = "T";
        } else {
            currentRow.NRSOLI = currentRow.NRSOLI.join("_");
        }
        if (!currentRow.CDGRUPFILI) {
            currentRow.CDGRUPFILI = "T";
        }
        var pad ='ZZZZZZZZZZ';
        var str = currentRow.CDPRODFIN;
        currentRow.CDPRODFIN    = widget.getField('CDPRODFIN').value() ? str + pad.substr(0,pad.length-str.length) : widget.getField('CDPRODFIN').value();
        currentRow.TDTINI       = currentRow.DTINI;
        currentRow.TDTFIM       = currentRow.DTFIM;

        General.openReport("/cmp05000_relatorio", reportName, currentRow).then(function() {
            
            if (!widget.getField('CDREGIAO_checkbox').checked) {
                currentRow.CDREGIAO = currentRow.CDREGIAO.split("_");
            } else {
                currentRow.CDREGIAO = '';
            } if (!widget.getField('CDFILSOLI_checkbox').checked) {
                currentRow.CDFILSOLI = currentRow.CDFILSOLI.split("_");
            } else {
                currentRow.CDFILSOLI = '';
            } if (!widget.getField('CDFILLAN_checkbox').checked) {
                currentRow.CDFILLAN = currentRow.CDFILLAN.split("_");
            } else {
                currentRow.CDFILLAN = '';
            } if (!widget.getField('NRSOLI_checkbox').checked) {
                currentRow.NRSOLI = currentRow.NRSOLI.split("_");
            } else {
                currentRow.NRSOLI = '';
            }
        });
    };

    this.atualizaAgrupamento = function(args){
        
        args.row.CDFILSOLI  = '';
        args.row.NRSOLI     = '';
    };

    this.atualizaRegiao = function(args){
        
        args.row.CDFILSOLI  = '';
        args.row.CDFILLAN   = '';
        args.row.NRSOLI     = '';
    };

    this.atualizaUnidade = function(args){
        
        args.row.NRSOLI = '';
    };

    this.validaData = function(currentRow, field) {

        var dataInicial = currentRow.DTINI ? moment(currentRow.DTINI, 'DD/MM/YYYY')._d : null;
        var dataFinal   = currentRow.DTFIM ? moment(currentRow.DTFIM, 'DD/MM/YYYY')._d : null;
 
        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.validaProduto = function(prodInicial, prodFinal){
        if(prodInicial || prodFinal){
            if(!prodInicial){
                MessageService.showMessageByCode("PRODINICIAL_NULO");
                return false;
            }
            if(!prodFinal){
                MessageService.showMessageByCode("PRODFINAL_NULO");
                return false;
            }
            if(!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }
        return true;
    };
}


Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp05000Controller', Cmp05000Controller);
});