function Cmp05400AFPedidoPorData (General, ScreenService, ZHPromise, restEngine, MessageService) {
	var filterParams;
    
    var concatArray = function(arr, defaultValue) {
	    return !Util.isEmptyOrBlank(arr) ? '_' + arr.join('_') + '_' : defaultValue || 'T';
	};

    this.onEnter = function (widget) {
    	widget.newRow();
    	
    	widget.currentRow.REPORT_NAME = "CMP05400";
    	widget.currentRow.RUPTURA_OL = [ 'T', 'U' ];
    	widget.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY');
        widget.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
        widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
        widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
        
        widget.getField("CDFILIAL").reload();
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                widget.currentRow.CDFILIAL = [ CDFILCENTCMP ];
                widget.currentRow.NMFILIAL = [ NMFILCENTCMP ];
                widget.getField("CDFILIAL").readOnly = false;
                widget.getField("CDFILIAL").reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	               if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete widget.currentRow.CDFILIAL;
    	               delete widget.currentRow.NMFILIAL;
    	               widget.getField("CDFILIAL").reload();
    	           }
                });
            } else {
                widget.getField("CDFILIAL").readOnly = true;
                widget.getField("CDFILIAL").reload().then(function(success) {
    	           if(widget.getField("CDFILIAL").readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.cmp05400_filial_grupfili_regiao.forEach(function(filial) {
    	                   if(filial.CDFILIAL == widget.currentRow.CDFILIAL[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   widget.getField("CDFILIAL").validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete widget.currentRow.CDFILIAL;
    	                   delete widget.currentRow.NMFILIAL;
    	                   widget.getField("CDFILIAL").reload();
    	               } else {
    	                   delete widget.getField("CDFILIAL").validations.required;
    	                   widget.getField("CDFILIAL").reload();
    	               }
    	           }
    	       });
            }
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
            widget.currentRow.CDFILIAL = [ getLocalVar("CDFILIAL") ];
            widget.currentRow.NMFILIAL = [ getLocalVar("NMFILIAL") ];
            widget.getField("CDFILIAL").reload();
        });
        
    };

	this.onClickCdfilial = function (fieldUnidadeDestino) {
		if (filterParams) {
			General.onClickDependentField(fieldUnidadeDestino, filterParams);
			
			fieldUnidadeDestino.dataSourceFilter = [
	            {
	                name: "P_LISTAREGIAO",
	                operator: "=",
	                value: filterParams.P_LISTAREGIAO
	            },
	            {
	                name: "P_CDGRUPFILI",
	                operator: "=",
	                value: filterParams.P_CDGRUPFILI
	            },
	            {
	                name: "P_CDOPERADOR",
	                operator: "=",
	                value: filterParams.P_CDOPERADOR
	            },
	            {
	                name: "NRORG",
	                operator: "=",
	                value: filterParams.NRORG
	            }
	        ];
		}
	};

	this.atualizaFiltroUnidadeDestino = function (widget) {
		var fieldUnidadeDestino = widget.getField('CDFILIAL'),
			currentRow = widget.currentRow;
	    
	    // Variável de escopo do controller
	    filterParams = {
            "P_LISTAREGIAO": concatArray(currentRow.CDREGIAO),
            "P_CDGRUPFILI": currentRow.CDGRUPFILI || 'T',
            "P_CDOPERADOR": getLocalVar('CDOPERADOR'),
            "NRORG": getLocalVar('NRORG')
        };
        
		fieldUnidadeDestino.clearValue();
	};

	this.acionaGerarRelatorio = function(widget) {
		if (widget.isValid()) {
			var currentRow = widget.currentRow;
			
			if (comparaProduto(currentRow.CDPRODINICIAL, currentRow.CDPRODFINAL)) {
				General.openReportPopup(widget, gerarRelatorio, [widget]);
			}
		}
	};
	
	var gerarRelatorio = function(widget) {
		var reportParams = montaParametrosRelatorio(widget.currentRow);
		General.openReport('cmp_fornecimento_emissaoAutorizacaoFornecimento#/cmp05400_af_pedido_por_data', widget.currentRow.REPORT_NAME, reportParams);
	};
	
	var montaParametrosRelatorio = function(currentRow) {
		var currentRowCopy = angular.copy(currentRow),
		params = {
			'QR2TYPE': currentRowCopy.QR2TYPE,
	        'REPORT_NAME': currentRowCopy.REPORT_NAME,
			'DTINI': currentRowCopy.DT_INTERVAL.start,
			'DTFIN': currentRowCopy.DT_INTERVAL.end,
			'DTINICIAL': currentRowCopy.DT_INTERVAL.start,
			'DTFINAL': currentRowCopy.DT_INTERVAL.end,
			'FILIAL': concatArray(currentRowCopy.CDFILIAL),
			'COMPRADOR': concatArray(currentRowCopy.CDOPERADOR),
			'IMPOSTO': concatArray(currentRowCopy.CDIMPOSTO),
			'REGIAO': concatArray(currentRowCopy.CDREGIAO),
			'FORNECEDOR': concatArray(currentRowCopy.NRINSJURFORN),
			'GRUPFILI': currentRowCopy.CDGRUPFILI || 'T',
			'FILIALPROC': getLocalVar('CDFILIAL'),
			'MODO': window.projectCorp ? 'N' : 'S',
			'IDTPGERARUP': concatArray(currentRowCopy.RUPTURA_OL)
		};
	    
		if (!currentRowCopy.CDPRODINICIAL && !currentRowCopy.CDPRODFINAL) {
    		params.PRODINICIAL = '0';
    		params.PRODFINAL = 'ZZZZZZZZZZZZZZZZZZZZ';
	        params.TODOSPROD = "T";
	        params.TODOSPROD1 = "T";
	        params.NMPRODINICIAL = "";
	        params.NMPRODFINAL = "";
    	} else {
    		params.PRODINICIAL = currentRowCopy.CDPRODINICIAL;
    		params.PRODFINAL = (currentRowCopy.CDPRODFINAL + 'ZZZZZZZZZZZZZZZZZZZZ').slice(0, 20);
    		params.TODOSPROD = "";
	        params.TODOSPROD1 = "";
	        params.NMPRODINICIAL = currentRowCopy.NMPRODINICIAL;
	        params.NMPRODFINAL = currentRowCopy.NMPRODFINAL;
    	}
    	
    	params.AUTOFORNE = (params.FORNECEDOR == 'T' || params.COMPRADOR == 'T') ? 'X' : 'T';
	    
	    return params;
	};

	var comparaProduto = function(produtoInicial, produtoFinal) {

		var intervaloValido = true;

		if (produtoInicial && !produtoFinal) {
			intervaloValido = false;
			MessageService.showMessageByCode("PRODFINAL_NULO", "ERROR");
		} else if (!produtoInicial && produtoFinal) {
			intervaloValido = false;
			MessageService.showMessageByCode("PRODINICIAL_NULO", "ERROR");
		} else if (produtoInicial && produtoFinal) {
			intervaloValido = General.comparaPratoProduto(produtoInicial, produtoFinal, getLocalVar('CDPICTPROD'));
			if (!intervaloValido) {
				MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", "ERROR");
			}
		}

		return intervaloValido;
	};
	
	this.toggleReadOnlyFields = function(widget) {
		/*
		Um dos campos escolhido aleatoriamente é utilizado como referência
		para evitar que diversos forEach sejam executados desnecessariamente.
		*/
		var fieldsAfetadosCMP05405_CMP05406 = [
				widget.getField('CDOPERADOR'),
				widget.getField('CDIMPOSTO'),
				widget.getField('NRINSJURFORN')
			],
			fieldsAfetadosCMP0540D = [
				widget.getField('RUPTURA_OL')
			],
			isReadOnly = widget.getField('CDOPERADOR').readOnly,
			isReadOnlyCMP0540D = widget.getField('RUPTURA_OL').readOnly,
			trataFields = function(fields, clausula, newValueReadOnly, clearValue, isObrigatorio) {
				if (clausula) {
					fields.forEach(function(field) {
						field.readOnly = newValueReadOnly;
						
						if (clearValue) {
							field.clearValue();
						}
						
						if (isObrigatorio) {
							field.validations = { required: true };
						}
					});
				}
			},
			trataFieldsDefault = function(fields) {
				fields.forEach(function(field) {
					if (field.name === 'RUPTURA_OL') {
						field.readOnly = true;
						field.validations = {};
						
						if (widget.currentRow.$error) {
							delete widget.currentRow.$error.RUPTURA_OL;
						}
					} else {
						field.readOnly = false;
						field.clearValue();
					}
				});
			};
			
		switch(widget.currentRow.REPORT_NAME) {
			case 'CMP05405':
				trataFields(fieldsAfetadosCMP05405_CMP05406, !isReadOnly, true, true, false);
				break;
			case 'CMP05406':
				trataFields(fieldsAfetadosCMP05405_CMP05406, !isReadOnly, true, true, false);
				break;
			case 'CMP0540D':
				trataFields(fieldsAfetadosCMP0540D, isReadOnlyCMP0540D, false, false, true);
				break;
			default:
				trataFieldsDefault(fieldsAfetadosCMP05405_CMP05406.concat(fieldsAfetadosCMP0540D));
		}
	};
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp05400AFPedidoPorData', Cmp05400AFPedidoPorData);
});